# Copyright (c) 2002-2005 Infrae. All rights reserved.
# See also LICENSE.txt
# $Revision: 1.3 $
import urllib
import zLOG
from zLOG import LOG,INFO
import time

def add_and_edit(self, id, REQUEST):
    """Helper function to point to the object's management screen if
    'Add and Edit' button is pressed.
    id -- id of the object we just added
    """
    if REQUEST is None:
        return
    try:
        u = self.DestinationURL()
    except:
        u = REQUEST['URL1']
    if REQUEST.has_key('submit_edit'):
        u = "%s/%s" % (u, urllib.quote(id))
    REQUEST.RESPONSE.redirect(u+'/manage_main')


def d_log(string, details=None):
    # comment in next line for debug
    #return
    if details is not None:
        zLOG.LOG('xml widgets debug',zLOG.INFO, string, details)
    else:
        zLOG.LOG('xml widgets debug',zLOG.INFO, string)

def aq_chain_str(obj):
    # skip the last element as it is the request, which has no id (?)
    # XXX just skipping the last element does not work, thus do it manually
    xx = []
    for o in obj.aq_chain:
        if not hasattr(o,'id'):
            #d_log(str(o)+' has no id attr ...')
            xx.append(str(o))
        else:
            xx.append(o.getId())
    xx.reverse()
    return '/'.join(xx)

def aq_tree(self, roots, widget_path, request=None):
    # private helper method to acquire some path via a merging different trees
    if not request:
        request = self.REQUEST
    req_other = request.other
    widget_cache = req_other.get('xml_widget_cache', {})
    #d_log('widget path: ' + str(widget_path))
    #d_log('roots: ' + str(roots))
    if widget_path[0] in roots:
        # HACK: interpret this as explicit selecting one tree ...
        # actually unnecessary, but maybe comes in handy ?
        #d_log('use explicit root '+widget_path[0])
        roots, widget_path = (widget_path[0],), widget_path[1:]

    widget_path_str = '/'.join(widget_path)
    if widget_cache.has_key(widget_path_str):
        return widget_cache[widget_path_str]

    widget = self
    for root in roots:
        #LOG('help',INFO,'root is: ' + str(root))
        object = getattr(widget, root, None)
        if object == None:
            # root does not exist (deleted manually ?)
            # XXX update _trees ? error message ?
            #d_log(root+' does not exist')
            continue
        #LOG('help',INFO,'object is: ' + str(object.absolute_url()))
        widget = object
        #LOG('help',INFO,'widget_path is: ' + str(widget_path))
        for id in widget_path:
            #d_log('acquiring '+id+' from '+aq_chain_str(widget) )
            object = getattr (widget, id, None)
            if object is None:
                #d_log('Failed. the buck stops here.')
                widget = self #reset widget
                break
            widget = object
        else:
            #d_log('resolved %s to %s' % (str(widget_path), aq_chain_str(widget) ) )
            widget_cache[widget_path_str] = widget
            req_other['xml_widget_cache'] = widget_cache
            return widget

    raise AttributeError, \
          ( '%s %s cannot acquire %s' % \
            ( self.meta_type, self.absolute_url(1), '/'.join(widget_path) ) )
